#include <stddef.h> // by J.C. Pzarro

void *__allocate_array_OptionA(size_t num, size_t size) {
   unsigned long long tmp = (unsigned long long)size * num;
   if (tmp >= 0x0000000080000000ULL) tmp=~size_t(0);
   return operator new[](tmp);
}

void *__allocate_array_OptionB(size_t num, size_t size) {
   unsigned long long tmp = (unsigned long long)size * num;
   if (tmp >= 0x0000000080000000ULL) return(operator new[](~size_t(0)));
   return operator new[](tmp);
}

// See http://www.cs.sjsu.edu/~kirchher/CS047/multDiv.html
//     One-operand imul:   &   Unsigned mul:

// warning: 32 bit, i686, possible risk of -x * -y = valid x * y, ...
// warning: it's made quick & dirty, possible to give clobbered situations.
// warning: it is not ready for x86-64, ppc, ppc64, etc.
// NO WARRANTY!!! IT'S VERY EXPERIMENTAL!!! NOT TESTED YET!!!
void *__allocate_array_OptionC(size_t num, size_t size) {
   register unsigned int result;
   __asm__ __volatile__
   (
           "orl $-1,%%ecx"
    "\n\t" "imull   %2" // See the flags OF, SF, CF, .. are affected or not.
    "\n\t" "cmovol %%ecx,%%eax" // i dude if it works or not. Not tested ...
//    "\n\t" "cmovcl %%ecx,%%eax"
    :"=a"(result)
    :"a"(num),"g"(size)
    :"%edx"/*???*/); // There are 0 conditional jumps!!! hehehehe!
   return operator new[](result);
}


// This function doesn't touch the ECX register that is touched by OptionC.

__volatile__ static const int minus_one = -1;

void *__allocate_array_OptionD(size_t num, size_t size) {
   register unsigned int result;
   __asm__ __volatile__
   (
           "imull   %2" // See the flags OF, SF, CF, .. are affected or not.
    "\n\t" "cmovol %3,%%eax" // i dude if it works or not. Not tested ...
//    "\n\t" "cmovcl %3,%%eax"
    :"=a"(result)
    :"a"(num),"m"(size),"m"(minus_one)
    :"%edx"/*???*/); // There are 0 conditional jumps!!! hehehehe!
   return operator new[](result);
}
